package com.ccnode.codegenerator.view.b.a;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.ccnode.codegenerator.ae.D;
import com.ccnode.codegenerator.k.a;
import com.ccnode.codegenerator.myconfigurable.Profile;
import com.intellij.codeInsight.editorActions.enter.EnterHandlerDelegate;
import com.intellij.codeInsight.editorActions.enter.EnterHandlerDelegateAdapter;
import com.intellij.lang.injection.InjectedLanguageManager;
import com.intellij.openapi.actionSystem.DataContext;
import com.intellij.openapi.diagnostic.Logger;
import com.intellij.openapi.editor.Caret;
import com.intellij.openapi.editor.CaretModel;
import com.intellij.openapi.editor.Editor;
import com.intellij.openapi.editor.actionSystem.EditorActionHandler;
import com.intellij.openapi.editor.actionSystem.EditorActionManager;
import com.intellij.openapi.editor.highlighter.EditorHighlighter;
import com.intellij.openapi.editor.highlighter.HighlighterIterator;
import com.intellij.openapi.fileEditor.FileEditorManager;
import com.intellij.openapi.project.Project;
import com.intellij.openapi.util.Key;
import com.intellij.openapi.util.Ref;
import com.intellij.psi.PsiDocumentManager;
import com.intellij.psi.PsiElement;
import com.intellij.psi.PsiFile;
import com.intellij.psi.codeStyle.CodeStyleManager;
import com.intellij.psi.tree.IElementType;
import com.intellij.psi.xml.XmlTokenType;
import org.jetbrains.annotations.NotNull;

public class g extends EnterHandlerDelegateAdapter {
  public static final Key<Boolean> a = Key.create("MybatisEnterStatementProcessing");
  
  public static Logger a = Logger.getInstance(com.ccnode.codegenerator.view.b.a.g.class);
  
  public EnterHandlerDelegate.Result preprocessEnter(@NotNull PsiFile paramPsiFile, @NotNull Editor paramEditor, @NotNull Ref<Integer> paramRef1, @NotNull Ref<Integer> paramRef2, @NotNull DataContext paramDataContext, EditorActionHandler paramEditorActionHandler) {
    Profile profile = a.a();
    if (paramPsiFile instanceof com.intellij.sql.psi.SqlFile || paramPsiFile instanceof com.ccnode.codegenerator.P.g || paramPsiFile instanceof com.intellij.lang.a.b) {
      Project project = paramPsiFile.getProject();
      PsiFile psiFile = InjectedLanguageManager.getInstance(project).getTopLevelFile((PsiElement)paramPsiFile);
      if (D.a.a(psiFile)) {
        Editor editor = FileEditorManager.getInstance(project).getSelectedTextEditor();
        CaretModel caretModel = editor.getCaretModel();
        if (profile.getDisAbleEnterTypeHandler()) {
          Caret caret = caretModel.getCurrentCaret();
          int i = caret.getOffset();
          if (a(project, editor, psiFile, i)) {
            editor.getDocument().insertString(i, "\n");
            if (project != null)
              CodeStyleManager.getInstance(project).adjustLineIndent(editor.getDocument(), i + 1); 
            return EnterHandlerDelegate.Result.DefaultForceIndent;
          } 
          String str = CodeStyleManager.getInstance(project).getLineIndent(psiFile, i);
          editor.getDocument().insertString(i, "\n");
          Integer integer = Integer.valueOf(i + 1);
          if (str != null) {
            editor.getDocument().insertString(i + 1, str);
            integer = Integer.valueOf(integer.intValue() + str.length());
          } 
          editor.getCaretModel().moveToOffset(integer.intValue());
          return EnterHandlerDelegate.Result.Stop;
        } 
        if (editor != null) {
          int i = caretModel.getCurrentCaret().getOffset();
          EditorActionHandler editorActionHandler = a();
          if (profile.getDebugMode())
            a.info("Current enter action handler is:" + editorActionHandler.getClass()); 
          editorActionHandler.execute(editor, caretModel.getCurrentCaret(), paramDataContext);
          int j = caretModel.getCurrentCaret().getOffset();
          if (j == i) {
            if (profile.getDebugMode())
              a.info("Mybatis Enter typeHandler offset is Equals:" + editorActionHandler.getClass()); 
            Caret caret = caretModel.getCurrentCaret();
            int k = caret.getOffset();
            if (a(project, editor, psiFile, k)) {
              editor.getDocument().insertString(k, "\n");
              if (project != null)
                CodeStyleManager.getInstance(project).adjustLineIndent(editor.getDocument(), k + 1); 
              return EnterHandlerDelegate.Result.DefaultForceIndent;
            } 
            String str = CodeStyleManager.getInstance(project).getLineIndent(psiFile, k);
            editor.getDocument().insertString(k, "\n");
            Integer integer = Integer.valueOf(k + 1);
            if (str != null) {
              editor.getDocument().insertString(k + 1, str);
              integer = Integer.valueOf(integer.intValue() + str.length());
            } 
            editor.getCaretModel().moveToOffset(integer.intValue());
            return EnterHandlerDelegate.Result.Stop;
          } 
          if (profile.getContinueEnterTypeHandler())
            return EnterHandlerDelegate.Result.Continue; 
          return EnterHandlerDelegate.Result.Stop;
        } 
      } 
    } 
    return EnterHandlerDelegate.Result.Continue;
  }
  
  private static EditorActionHandler a() {
    return EditorActionManager.getInstance().getActionHandler("EditorEnter");
  }
  
  private static boolean a(Project paramProject, Editor paramEditor, PsiFile paramPsiFile, int paramInt) {
    if (paramInt == 0)
      return false; 
    CharSequence charSequence = paramEditor.getDocument().getCharsSequence();
    if (charSequence.charAt(paramInt - 1) != '>')
      return false; 
    EditorHighlighter editorHighlighter = paramEditor.getHighlighter();
    HighlighterIterator highlighterIterator = editorHighlighter.createIterator(paramInt - 1);
    if (highlighterIterator.getTokenType() != XmlTokenType.XML_TAG_END)
      return false; 
    if (a(paramProject, paramEditor, paramPsiFile, highlighterIterator))
      return false; 
    highlighterIterator.retreat();
    byte b1 = 1;
    while (!highlighterIterator.atEnd()) {
      IElementType iElementType = highlighterIterator.getTokenType();
      if (iElementType == XmlTokenType.XML_END_TAG_START)
        return false; 
      if (iElementType == XmlTokenType.XML_START_TAG_START)
        break; 
      b1++;
      highlighterIterator.retreat();
    } 
    for (byte b2 = 0; b2 < b1; ) {
      highlighterIterator.advance();
      b2++;
    } 
    highlighterIterator.advance();
    return (!highlighterIterator.atEnd() && highlighterIterator.getTokenType() == XmlTokenType.XML_END_TAG_START);
  }
  
  private static boolean a(Project paramProject, Editor paramEditor, PsiFile paramPsiFile, HighlighterIterator paramHighlighterIterator) {
    if (paramHighlighterIterator.getTokenType() != XmlTokenType.XML_TAG_END)
      return false; 
    PsiDocumentManager.getInstance(paramProject).commitDocument(paramEditor.getDocument());
    PsiElement psiElement1 = paramPsiFile.findElementAt(paramHighlighterIterator.getStart());
    if (psiElement1 == null)
      return false; 
    PsiElement psiElement2 = psiElement1.getParent();
    return (psiElement2 instanceof com.intellij.psi.xml.XmlTag && psiElement2
      .getTextRange().getEndOffset() == paramHighlighterIterator.getEnd());
  }
}
